package ovh.gasser.newshapes.util;

import io.reactivex.Observable;

import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

public class EventSource {
    public static Observable<MouseEvent> fromMouseEventsOf(final Component component) {
        return Observable.create(emitter -> {
            final MouseAdapter adapter = new MouseAdapter() {
                @Override
                public void mousePressed(MouseEvent e) {
                    emitter.onNext(e);
                }

                @Override
                public void mouseDragged(MouseEvent e) {
                    emitter.onNext(e);
                }
            };
            component.addMouseMotionListener(adapter);
            component.addMouseListener(adapter);
            emitter.setCancellable(() -> component.removeMouseListener(adapter));
        });
    }
}
